#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int SZ = 16384, MOD = 163841, SZ2 = SZ * 4;
ll arr[SZ * 6], tmpa[SZ2], tmpb[SZ2], tmp[SZ2];
ll* free_from = tmp;
ll* free_tmpa = tmpa;
ll* free_tmpb = tmpb;

void prod(ll* l1, ll* r1, ll* l2, ll* r2, ll* l3, ll* r3) {
    if (r1 - l1 == 1) {
        *l3 += *l1 * *l2;
        return;
    }
    int sz = r1 - l1;
    ll* m1 = l1 + sz / 2;
    ll* m2 = l2 + sz / 2;
    ll* m3 = l3 + sz;
    prod(l1, m1, l2, m2, l3, m3);
    prod(m1, r1, m2, r2, m3, r3);
    assert(free_from - tmp + sz <= SZ2 && free_tmpa - tmpa + sz / 2 <= SZ2 && free_tmpb - tmpb + sz / 2 <= SZ2);
    
    for (int i = 0; i < sz / 2; ++i) {
        *(free_tmpa + i) = *(l1 + i) + *(m1 + i);
        *(free_tmpb + i) = *(l2 + i) + *(m2 + i);
    }
    
    fill(free_from, free_from + sz, 0);
    free_from += sz;
    free_tmpa += sz / 2;
    free_tmpb += sz / 2;
    prod(free_tmpa - sz / 2, free_tmpa, free_tmpb - sz / 2, free_tmpb, free_from - sz, free_from);
    free_from -= sz;
    free_tmpa -= sz / 2;
    free_tmpb -= sz / 2;
    
    for (int i = 0; i < sz; ++i) {
        *(free_from + i) -= *(l3 + i) + *(m3 + i);
    }
    for (int i = 0; i < sz; ++i) {
        *(l3 + sz / 2 + i) += *(free_from + i);
    }
}

void prod(ll* l1, ll* l2, ll* l3) {
    fill(l3, l3 + SZ * 2, 0);
    prod(l1, l1 + SZ, l2, l2 + SZ, l3, l3 + SZ * 2);
    for (int i = 0; i < SZ; ++i) {
        *(l3 + i) %= MOD;
    }
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    /*
    ll *a = arr, *b = arr + SZ, *c = arr + SZ * 2;
    a[0] = 1, a[1] = 2, a[2] = 3;
    b[0] = 2, b[1] = 1, b[2] = 5;
    prod(a, b, c);
    for (int i = 10; i >= 0; --i) {
        cerr << c[i] << " ";
    }
    cerr << endl;
    */
    
    int n, k, q;
    scanf("%d%d%d", &n, &k, &q);

    ll* v = arr;
    for (int i = 0; i < n; ++i) {
        int c;
        scanf("%d", &c);
        v[c]++;
    }

    ll* res = arr + SZ * 2;
    res[0] = 1;
    ll* mem = arr + SZ * 4;

    prod(v, res, mem);

    while (k) {
        if (k & 1) {
            prod(res, v, mem);
            swap(res, mem);
        }
        prod(v, v, mem);
        swap(v, mem);
        k /= 2;
    }

    vector<int> pref({0});
    for (int i = 1; i < SZ; ++i) {
        pref.puba((pref.back() + res[i]) % MOD);
    }

    for (int i = 0; i < q; ++i) {
        int l, r;
        scanf("%d%d", &l, &r);
        --l;
        int ans = (pref[r] - pref[l]) % MOD;
        if (ans < 0) {
            ans += MOD;
        }
        cout << ans << "\n";
    }
    
    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}