#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXC = 1000000;

bool check_dist(ll dx, ll dy, ll dist) {
    return dx * dx + dy * dy > dist * dist;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    while (true) {
        ll x1 = rnd.next(-MAXC, MAXC);
        ll y1 = rnd.next(-MAXC, MAXC);
        ll x2 = rnd.next(-MAXC, MAXC);
        ll y2 = rnd.next(-MAXC, MAXC);

        long double d = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
        ll sr = (ll) d;
        ll r1 = rnd.next(sr / 3, sr * 2 / 3);
        ll r2 = sr - r1;

        ll x0 = x1 + (x2 - x1) * r1 / sr;
        ll y0 = y1 + (y2 - y1) * r1 / sr;
        for (int i = -5; i <= 5; ++i) {
            for (int j = -5; j <= 5; ++j) {
                ll x = x0 + i;
                ll y = y0 + j;
                if (-MAXC <= x && x <= MAXC && -MAXC <= y && y <= MAXC && r1 <= MAXC && r2 <= MAXC && check_dist(x1 - x, y1 - y, r1) && check_dist(x2 - x, y2 - y, r2) && check_dist(x1 - x2, y1 - y2, r1 + r2)) {
                    cout << x1 << " " << y1 << " " << r1 << "\n" << x2 << " " << y2 << " " << r2 << "\n" << x << " " << y << "\n";
                    return 0;
                }
            }
        }
        
        
    }

    return 0;
}