#include "testlib.h"
#include <string>
using namespace std;

const int MAXX = 1e9;
const int MAXN = 100;

template<typename T>
string str(const T& x) 
{
    stringstream ss;
    ss << x;
    return ss.str();
}


int main(int argc, char * argv[]) 
{
    registerValidation(argc, argv);
    int n = inf.readInt(1, MAXN, "n");
    inf.readEoln();
    for (int j = 0; j < n; j++)
    {
        inf.readInt(1, MAXX, "a[" + to_string(j + 1) + "]");
        if (j < n - 1)
            inf.readSpace();
    }
    inf.readEoln();
    inf.readEof();
    return 0;
}