#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int MAXN = 100000;
int n, k, t;
int p[MAXN];

long long count(int tm) {
    if (1LL * n * tm <= 100000000) {
        long long ans = 0;
        for (int i = 1; i <= tm; i++) {
            for (int j = 0; j < n; j++) {
                if (i % p[j] == 0) {
                    ans++;
                }
            }
        }
        return ans;
    } else {
        long long ans = 0;
        priority_queue<pair<int, int>> nxt;
        for (int i = 0; i < n; i++) {
            nxt.push({-p[i], p[i]});
        }
        for (int i = 1; i <= tm; i++) {
            while (nxt.top().first == -i) {
                auto pp = nxt.top();
                nxt.pop();
                pp.first -= pp.second;
                nxt.push(pp);
                ans++;
            }
        }
        return ans;
    }
}

int main() {
    scanf("%d%d%d", &n, &k, &t);
    for (int i = 0; i < n; i++) {
        scanf("%d", &p[i]);
    }

    if (k >= t) {
        cout << count(t) << endl;
        return 0;
    }

    cout << count(k) * (t / k) + count(t % k) << endl;

    return 0;
}
