#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int BASE = 17, SZ = 1 << BASE, MOD = 786433;
ll arr[SZ * 3], arra[SZ], arrb[SZ];

ll mpow(ll a, ll b) {
    ll ret = 1;
    while (b) {
        if (b & 1) {
            ret = ret * a % MOD;
        }
        a = a * a % MOD;
        b /= 2;
    }
    return ret;
}

int rev[SZ];

void dft(ll* a) {
    for (int i = 0; i < SZ; ++i) {
        if (i < rev[i]) {
            swap(a[i], a[rev[i]]);
        }
    }
    for (int i = 1; i < SZ; i *= 2) {
        ll root = mpow(25, SZ / i / 2);
        for (int j = 0; j < SZ; j += i * 2) {
            ll mul = 1;
            for (int k = 0; k < i; ++k) {
                ll l = a[j + k];
                ll r = a[j + i + k] * mul % MOD;
                a[j + k] = (l + r) % MOD;
                a[j + i + k] = (l - r + MOD) % MOD;
                mul = mul * root % MOD;
            }
        }
    }
}

void prod(ll* l1, ll* l2, ll* l3) {
    for (int i = 0; i < SZ; ++i) {
        arra[i] = l1[i];
        arrb[i] = l2[i];
    }
    dft(arra);
    dft(arrb);
    for (int i = 0; i < SZ; ++i) {
        l3[i] = arra[i] * arrb[i] % MOD;
    }
    dft(l3);
    ll back = mpow(SZ, MOD - 2);
    for (int i = 0; i < SZ; ++i) {
        l3[i] = l3[i] * back % MOD;
    }
    reverse(l3 + 1, l3 + SZ);
    for (int i = SZ / 2; i < SZ; ++i) {
        l3[i] = 0;
    }
}


int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);
    cerr << fixed << setprecision(15);
    cout << fixed << setprecision(15);
    
    for (int i = 0; i < SZ; ++i) {
        rev[i] = (rev[i >> 1] >> 1) | ((i & 1) << (BASE - 1));
    }

    int n, k, q;
    scanf("%d%d%d", &n, &k, &q);

    ll* v = arr;
    for (int i = 0; i < n; ++i) {
        int c;
        scanf("%d", &c);
        v[c]++;
    }

    ll* res = arr + SZ;
    res[0] = 1;
    ll* mem = arr + SZ * 2;

    while (k) {
        if (k & 1) {
            prod(res, v, mem);
            swap(res, mem);
        }
        prod(v, v, mem);
        swap(v, mem);
        k /= 2;
    }

    vector<int> pref({0});
    for (int i = 1; i < SZ; ++i) {
        pref.puba((pref.back() + res[i]) % MOD);
    }

    for (int i = 0; i < q; ++i) {
        int l, r;
        scanf("%d%d", &l, &r);
        --l;
        int ans = (pref[r] - pref[l]) % MOD;
        if (ans < 0) {
            ans += MOD;
        }
        cout << ans << "\n";
    }

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}